# CGI Bash Shell Interface

CBSI is a small program that makes CGI programming in the Bash Shell a lot
easier, or at least more tolerable. It is intended for Kagera Firmware, where
other languages are too big.

It parses POST and GET requests in addiction to COOKIES, placing elements as
`name=value` pairs into the environment for the CGI script to use.

It combines three features into an engine: 
 * It opens a shell, and translates all text into printable statements. All
   text within <% ... %> constructs are passed verbatim to the shell.
 * It opens a shell, and prints the shell expression. Everything within
   <%: ... %> tags are supposed to be parsed into 'echo' statement.
 * It supports multilanguage and allows to easily put all texts within
   <%@ ... %> tags to be quick and easily translated into chosen language.

Additional parameters that can be passed to CBSI:
 * --language-dir=pathspec  - specifies a directory where CBSI should look for
                              scripts translations. Default value is
                              '/usr/lib/kagera/langs'
 * --shell=pathspec         - specifies an alternate bash-like shell to use.
                              This defaults to '/bin/sh'
 * --translation=filename   - specifies a dictionary filename to be loaded in
                              addiction to common.dic from language directory.
                              The extension is added automatically.
 * --upload-dir=pathspec    - this specifies a temporary directory where all
                              uploaded files are created. Defaults to '/tmp'
 * --upload-limit=limit     - allows a mime-encoded file up to limit KB to be
                              uploaded. The default value is 0KB (no limit).

This software is based on Haserl <http://haserl.sourceforge.net/>.
